;Copyright: Daniel Marjamki (daniel.marjamaki@home.se)
;
;: `nasm sampleboot.asm -o boot.bin`
;  boot.bin     !

[ORG 0]

            jmp 07C0h:start     ; Goto segment 07C0 //    070h

    start:
            ; Update the segment registers //   
            mov ax, cs
            mov ds, ax
            mov es, ax


    reset:                      ; Reset the floppy drive     //  ()  
            mov ax, 0           ;                           //
            mov dl, 0           ; Drive=0 (=A)             //
            int 13h             ;                         //   
            jc reset            ; ERROR => reset again   //      


    read:
            mov ax, 1000h       ; ES:BX = 1000:0000
            mov es, ax          ;
            mov bx, 0           ;

            mov ah, 2           ; Load disk data to ES:BX //      ES:BX
            mov al, 5           ; Load 5 sectors         //   5 
            mov ch, 0           ; Cylinder=0            //   
            mov cl, 2           ; Sector=2             //    (  - bootsector!!!) :-)
            mov dh, 0           ; Head=0              //   
            mov dl, 0           ; Drive=0            //    (!)
            int 13h             ; Read!             //  !

            jc read             ; ERROR => Try again       //      
                                ;                         //    
                                ;                        //
            jmp 1000h:0000      ; Jump to the program   //     


    times 510-($-$$) db 0
    dw 0AA55h